org 51000

counter EQU inc_counter + 1
attrs EQU &5800
xylo EQU attrs + 40

zero_counter:
	xor a

set_counter:
	ld (counter), a

read_keyboard:
	ld a, &f7
	in a, (&fe)
	rra
	jr nc, key_1
	rra
	jr nc, key_2
	rra
	jr nc, key_3
	rra
	jr nc, key_4
	rra
	jr nc, key_5
	jr read_keyboard

key_1:
	ld e, 0
	call highlight_key
	ld a, (counter)
	call play
	ld e, 0
	jr keyoff

key_2:
	ld e, 3
	call highlight_key
	ld a, (counter)
	inc a
	call play
	ld e, 3
	jr keyoff

key_3:
	ld e, 6
	call highlight_key
	ld a, (counter)
	inc a
	inc a
	call play
	ld e, 6
	jr keyoff

key_4:
	ld e, 9
	call highlight_key
	ld a, (counter)
	add a, 3
	call play
	ld e, 9
	jr keyoff

key_5:
	ld e, 12
	call highlight_key
	ld a, (counter)
	add a, 4
	call play
	ld e, 12
keyoff:
	call highlight_key

inc_counter:
	ld a, 0		;This value will be modified by the running code
	add a, 5
	cp 25
	jr nz, set_counter
	jr zero_counter

highlight_key:
	ld hl, xylo
	ld d, 0
	add hl, de
	ld b, 15
highlight_row:
	ld c, 3
highlight_block:
	ld a, (hl)
	xor %01000000
	ld (hl), a
	inc hl
	dec c
	jr nz, highlight_block
	ld e, 29
	add hl, de
	djnz highlight_row
	ret

INCLUDE "sample.asm"
